# this is a simple python script to capture the UDP packets
# that are broadcast by dash launch, display that info
# in human readable form and log the data to a csv file
# note, there is also another sample for using this data on a PC in launch_sysdll_exports.c
import socket, sys, time

port = 7030

dgr = unichr(176)
s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
s.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
s.bind(('', port))
divisor = float(256)
header = 'CPU,GPU,EDRAM,MOBO,UNK,Time,Date,PEName,Path,TID,MID\n'

def get_len(var, max):
	for i in range(max):
		if ord(var[i]) == 0x0:
			return (i)
	return 0

def tempPoll(lf):
	message = s.recv(0x200)
	# uncomment this bit if you want to view the raw data too
	# out_str = "raw: "
	# for num in xrange(16):
		# out_str += "0x%02x " % (ord(message[num]))
	# print out_str
	if ord(message[0]) == 0x7:
		cpu = float((ord(message[1])+(ord(message[2])<<8))/divisor)
		gpu = float((ord(message[3])+(ord(message[4])<<8))/divisor)
		edr = float((ord(message[5])+(ord(message[6])<<8))/divisor)
		mob = float((ord(message[7])+(ord(message[8])<<8))/divisor)
		unk = ord(message[9])
		pename = "%s" % (message[0x10:(get_len(message[0x10:], 0x50))+0x10])
		image = "%s" % (message[0x60:(get_len(message[0x60:], 0x100)+0x60)])
		tid = (ord(message[0x160])<<24)+(ord(message[0x161])<<16)+(ord(message[0x162])<<8)+ord(message[0x163])
		mid = (ord(message[0x164])<<24)+(ord(message[0x165])<<16)+(ord(message[0x166])<<8)+ord(message[0x167])
		st = "%0.1f,%0.1f,%0.1f,%0.1f,%d,%s,%s,%s,%08x,%08x\n" % (cpu, gpu, edr, mob, unk, time.strftime("%H:%M:%S,%m/%d/%Y"), pename, image, tid, mid)
		lf.write(st)
		print "CPU: %0.1f%sC GPU: %0.1f%sC EDRAM: %0.1f%sC MOBO: %0.1f%sC Unk: %d %s image: %s @ %s T: 0x%08x M: 0x%08x" % (cpu, dgr, gpu, dgr, edr, dgr, mob, dgr, unk, time.strftime("%I:%M:%S%p"), pename, image, tid, mid)
	else:
		print "ERRROR!!! 0x%x is not a temp reply!!!" % (ord(message[0]))

if __name__ == '__main__':
	logfile = 'temps.csv'
	if (len(sys.argv) == 1):
		logfile = "temps_%s.csv" % (time.strftime("%I.%M.%S%p_%m.%d.%Y"))
		lfile = open(logfile, 'w')
	else:
		logfile = sys.argv[0]
	print "Opening log: %s" % (logfile)
	lfile = open(logfile, 'w')
	lfile.write(header)

	while True:
		try:
			tempPoll(lfile)
		except KeyboardInterrupt:
			lfile.close()
			sys.exit()
			
